//yes I know there's executable code here
//it's simple to just #include it
#ifndef CSM_UTILS
#define CSM_UTILS
gboolean csm_load_option(GKeyFile * schemaFile, gchar * sect, gchar * dval, CompOption * o,CompOptionValue * v,
        CompDisplay * cd);
void csm_save_option(GKeyFile * schemaFile, gchar * sect, gchar * dval, CompOption * o,
        CompDisplay * cd);
gboolean csm_load_option(GKeyFile * schemaFile, gchar * sect, gchar * dval, CompOption * o,CompOptionValue * v,
        CompDisplay * cd)
{
    GError * e = NULL;
    gboolean b;
    gint i;
    gchar * s;
    gdouble f;
    switch(o->type)
    {
        case CompOptionTypeBool:
            b=g_key_file_get_boolean(schemaFile,sect,dval,&e);
            if (!e)
            {
                v->b=b;
                return TRUE;
            }
            break;
        case CompOptionTypeInt:
            i=g_key_file_get_integer(schemaFile,sect,dval,&e);
            if (!e)
            {
                v->i=i;
                return TRUE;
            }
            break;
        case CompOptionTypeString:
            s=g_key_file_get_string(schemaFile,sect,dval,&e);
            if (s)
            {
                if (v->s)
                    free(v->s);
                v->s=s;
                return TRUE;
            }
            break;
        case CompOptionTypeFloat:
            s=g_key_file_get_string(schemaFile,sect,dval,&e);
            if (s)
            {
                f=g_ascii_strtod(s,NULL);
                g_free(s);
                v->f=f;
                return TRUE;
            }
            break;
        case CompOptionTypeColor:
            {
                gint * c;
                gsize l=0;
                c=g_key_file_get_integer_list(schemaFile,sect,dval,&l,&e);
                if (!e && l>=4)
                {
                    v->c[0]=c[0];
                    v->c[1]=c[1];
                    v->c[2]=c[2];
                    v->c[3]=c[3];
                    g_free(c);
                    return TRUE;
                }
            }
            break;
        case CompOptionTypeAction:
            {
                gint * d;
                gsize l=0;
                d=g_key_file_get_integer_list(schemaFile,sect,dval,&l,&e);
                if (!e && l>=6)
                {
                    v->action=o->value.action;
                    v->action.type=CompBindingTypeNone;
                    v->action.button.modifiers=d[0];
                    v->action.button.button=d[1];
                    if (d[1]!=0)
                        v->action.type|=CompBindingTypeButton;
                    v->action.key.modifiers=d[2];
                    v->action.key.keycode=0;
                    if (d[3]!=0)
                    {
                        v->action.key.keycode=XKeysymToKeycode(cd->display,d[3]);
                        v->action.type|=CompBindingTypeKey;
                    }
                    v->action.edgeMask=d[4];
                    v->action.bell=d[5]==1?TRUE:FALSE;
                    g_free(d);
                    return TRUE;
                }
            }
            break;
        case CompOptionTypeList:
            {
                gint i;
                v->list.type = o->value.list.type;
                switch(o->value.list.type)
                {
                    gsize l=0;
                    case CompOptionTypeBool:
                        {
                            gboolean * d = g_key_file_get_boolean_list(
                                    schemaFile,sect,dval,&l,&e);
                            if (!e)
                            {
                                if (v->list.nValue && v->list.value)
                                {
                                    v->list.nValue=0;
                                    free(v->list.value);
                                }
                                v->list.nValue=l;
                                v->list.value=malloc(sizeof(CompOptionValue)*l);
                                for (i=0;i<l;i++)
                                    v->list.value[i].b=d[i];
                                g_free(d);
                                return TRUE;
                            }
                        }
                        break;
                    case CompOptionTypeInt:
                        {
                            gint * d = g_key_file_get_integer_list(
                                    schemaFile,sect,dval,&l,&e);
                            if (!e)
                            {
                                if (v->list.nValue && v->list.value)
                                {
                                    v->list.nValue=0;
                                    free(v->list.value);
                                }
                                v->list.nValue=l;
                                v->list.value=malloc(sizeof(CompOptionValue)*l);
                                for (i=0;i<l;i++)
                                    v->list.value[i].i=d[i];
                                g_free(d);
                                return TRUE;
                            }
                        }
                        break;
                    case CompOptionTypeString:
                        {
                            gchar ** d = g_key_file_get_string_list(schemaFile,sect,
                                    dval,&l,&e);
                            if (!e)
                            {
                                if (v->list.nValue && v->list.value)
                                {
                                    v->list.nValue=0;
                                    free(v->list.value);
                                }
                                v->list.nValue=l;
                                v->list.value=malloc(sizeof(CompOptionValue)*l);
                                
                                for(i=0;i<l;i++)
                                {
                                    if (!d[i])
                                        v->list.value[i].s=strdup("");
                                    else
                                        v->list.value[i].s=strdup(d[i]);
                                }

                                g_strfreev(d);
                                return TRUE;
                            }
                        }
                        break;
                    case CompOptionTypeFloat:
                        {
                            gchar ** d = g_key_file_get_string_list(schemaFile,sect,
                                    dval,&l,&e);
                            if (!e)
                            {
                                if (v->list.nValue && v->list.value)
                                {
                                    v->list.nValue=0;
                                    free(v->list.value);
                                }
                                v->list.nValue=l;
                                v->list.value=malloc(sizeof(CompOptionValue)*l);
                                
                                for(i=0;i<l;i++)
                                    v->list.value[i].f=g_ascii_strtod(d[i],NULL);

                                g_strfreev(d);
                                return TRUE;
                            }
                        }
                        break;
                    case CompOptionTypeAction:
                        {
                            gint * d = g_key_file_get_integer_list(
                                    schemaFile,sect,dval,&l,&e);
                            if (!e && l%6==0)
                            {
                                if (v->list.nValue && v->list.value)
                                {
                                    v->list.nValue=0;
                                    free(v->list.value);
                                }
                                v->list.nValue=l/6;
                                v->list.value=malloc(sizeof(CompOptionValue)*l);
                                for(i=0;i<(l/6);i++)
                                {
                                    v->list.value[i].action.button.modifiers=d[i*6];
                                    v->list.value[i].action.button.button=d[i*6+1];
                                    v->list.value[i].action.key.modifiers=d[i*6+2];
                                    v->list.value[i].action.key.keycode=
                                        XKeysymToKeycode(cd->display,d[i*6+3]);
                                    v->list.value[i].action.edgeMask=d[i*6+4];
                                    v->list.value[i].action.bell=d[i*6+5]==1?TRUE:FALSE;
                                }
                                g_free(d);
                                return TRUE;
                            }
                        }
                        break;
                    case CompOptionTypeColor:
                        {
                            gint * d = g_key_file_get_integer_list(
                                    schemaFile,sect,dval,&l,&e);
                            if (!e && l%4==0)
                            {
                                if (v->list.nValue && v->list.value)
                                {
                                    v->list.nValue=0;
                                    free(v->list.value);
                                }
                                v->list.nValue=l/4;
                                v->list.value=malloc(sizeof(CompOptionValue)*l);
                                for(i=0;i<(l/4);i++)
                                {
                                    v->list.value[i].c[0]=d[i*4];
                                    v->list.value[i].c[1]=d[i*4+1];
                                    v->list.value[i].c[2]=d[i*4+2];
                                    v->list.value[i].c[3]=d[i*4+3];
                                }
                                g_free(d);
                            }
                            return TRUE;
                        }
                        break;
                    case CompOptionTypeList:
                        g_error("List type is not a valid list type");
                }
            }
    }
    return FALSE;
}
void csm_save_option(GKeyFile * schemaFile, gchar * sect, gchar * dval, CompOption * o,
        CompDisplay * cd)
{
    switch(o->type)
    {
        case CompOptionTypeBool:
            g_key_file_set_boolean(schemaFile,sect,dval,o->value.b);
            break;
        case CompOptionTypeInt:
            g_key_file_set_integer(schemaFile,sect,dval,o->value.i);
            break;
        case CompOptionTypeString:
            g_key_file_set_string(schemaFile,sect,dval,o->value.s);
            break;
        case CompOptionTypeFloat:
            {
                gchar s[G_ASCII_DTOSTR_BUF_SIZE];
                g_ascii_dtostr(s,G_ASCII_DTOSTR_BUF_SIZE,o->value.f);
                g_key_file_set_string(schemaFile,sect,dval,s);
            }
            break;
        case CompOptionTypeColor:
            {
                gint c[4];
                c[0]=o->value.c[0];
                c[1]=o->value.c[1];
                c[2]=o->value.c[2];
                c[3]=o->value.c[3];
                g_key_file_set_integer_list(schemaFile,sect,dval,c,4);
            }
            break;
        case CompOptionTypeAction:
            {
                //format...
                //string list
                //button;key;edge;bell;
                //button-format
                //  modifiers(int);button(int);
                //key-format
                //  modifiers(int);keysym(int);
                //edge-format
                //  edgemask(int)
                //bell-format
                //  on_bell(int)
                gint d[6];
                d[0]=o->value.action.button.modifiers;
                d[1]=(o->value.action.type & CompBindingTypeButton)?
                    o->value.action.button.button:0;
                d[2]=o->value.action.key.modifiers;
                d[3]=(o->value.action.type & CompBindingTypeKey)?
                    XKeycodeToKeysym(cd->display,o->value.action.key.keycode,0)
                    :0;
                d[4]=o->value.action.edgeMask;
                d[5]=o->value.action.bell?1:0;
                g_key_file_set_integer_list(schemaFile,sect,dval,d,6);
            }
            break;
        case CompOptionTypeList:
            {
                gint i;
                switch(o->value.list.type)
                {
                    case CompOptionTypeBool:
                        {
                            gboolean * d = malloc(sizeof(gboolean)*o->value.list.nValue);
                            for (i=0;i<o->value.list.nValue;i++)
                                d[i]=o->value.list.value[i].b;
                            g_key_file_set_boolean_list(schemaFile,sect,dval,d,o->value.list.nValue);
                            free(d);
                        }
                        break;
                    case CompOptionTypeInt:
                        {
                            gint * d = malloc(sizeof(gint)*o->value.list.nValue);
                            for (i=0;i<o->value.list.nValue;i++)
                                d[i]=o->value.list.value[i].i;
                            g_key_file_set_integer_list(schemaFile,sect,dval,d,o->value.list.nValue);
                            free(d);
                        }
                        break;
                    case CompOptionTypeString:
                        {
                            gchar ** d = malloc(sizeof(gchar *)*o->value.list.nValue);
                            for(i=0;i<o->value.list.nValue;i++)
                                d[i]=o->value.list.value[i].s;
                            g_key_file_set_string_list(schemaFile,sect,dval,
                                    (const gchar **)d,o->value.list.nValue);
                            free(d);
                        }
                        break;
                    case CompOptionTypeFloat:
                        {
                            gchar ** d = malloc(sizeof(gchar *)*o->value.list.nValue);
                            for (i=0;i<o->value.list.nValue;i++)
                            {
                                d[i]=malloc(G_ASCII_DTOSTR_BUF_SIZE);
                                g_ascii_dtostr(d[i],G_ASCII_DTOSTR_BUF_SIZE,
                                        o->value.list.value[i].f);
                            }
                            g_key_file_set_string_list(schemaFile,sect,dval,
                                    (const gchar **) d,o->value.list.nValue);
                            for (i=0;i<o->value.list.nValue;i++)
                                free(d[i]);
                            free(d);
                        }
                        break;
                    case CompOptionTypeAction:
                        {
                            gint * d = malloc(sizeof(gint)*o->value.list.nValue*6);
                            for(i=0;i<o->value.list.nValue;i++)
                            {

                                d[i*6]=o->value.list.value[i].action.button.modifiers;
                                d[i*6+1]=(o->value.list.value[i].action.type & CompBindingTypeButton)
                                    ?o->value.list.value[i].action.button.button:0;
                                d[i*6+2]=o->value.list.value[i].action.key.modifiers;
                                d[i*6+3]=(o->value.list.value[i].action.type & CompBindingTypeKey)
                                    ?XKeycodeToKeysym(cd->display,
                                        o->value.list.value[i].action.key.keycode,0):0;
                                d[i*6+4]=o->value.list.value[i].action.edgeMask;
                                d[i*6+5]=o->value.list.value[i].action.bell?1:0;
                            }
                            g_key_file_set_integer_list(schemaFile,sect,dval,d,
                                    o->value.list.nValue*6);
                            free(d);
                        }
                        break;
                    case CompOptionTypeColor:
                        {
                            gint * d = malloc(sizeof(gint)*o->value.list.nValue*4);
                            for(i=0;i<o->value.list.nValue;i++)
                            {
                                gint j;
                                for(j=0;j<4;j++)
                                {
                                    d[i*4+j]=o->value.list.value[i].c[j];
                                }
                            }
                            g_key_file_set_integer_list(schemaFile,sect,dval,d,
                                    o->value.list.nValue*4);
                            free(d);
                        }
                        break;
                    case CompOptionTypeList:
                        g_error("List type is not a valid list type");
                }
            }
    }
}
#endif
